<template>
  <div class="h-100">
    <h3 class="text-center div_title">Modules</h3>

    <div class="container-form">
      <div v-if="selectedPlugin == null">
        <h4>
          <b-icon icon="list-check" aria-hidden="true"></b-icon>
          Liste des modules disponible
        </h4>
        <b-row
          v-for="plugin in plugins"
          :key="plugin.id"
          class="plugin-element"
        >
          <b-col cols="10">
            <b-form-checkbox v-model="plugin.isActive" switch>
              <span
                v-b-tooltip.hover
                :title="plugin.description"
                style="cursor: help"
                class="text-second"
              >
                <b-icon icon="info-circle"></b-icon>
              </span>
              {{ plugin.label }}
            </b-form-checkbox>
          </b-col>
          <b-col
            cols="2"
            v-if="plugin.parameters.length"
            @click="onEdit(plugin)"
            class="text-center text-first"
            style="cursor: pointer"
          >
            <b-icon icon="gear"></b-icon>
          </b-col>
        </b-row>
      </div>

      <PluginEditPanel
        v-if="selectedPlugin !== null"
        @updateDone="selectedPlugin = null"
        :selectedPlugin="selectedPlugin"
      />
    </div>
  </div>
</template>

<script lang="ts">

import Component from 'vue-class-component';
import FormTextInput from '@/components/shared/FormTextInput.vue';
import FormNumberInput from '@/components/shared/FormNumberInput.vue';
import BaseComponent from '@/components/BaseComponent';
import Plugin from '@/models/plugin/Plugin';
import PluginEditPanel from './PluginEditPanel.vue';

@Component({
  props: {
  },
  components: {
    FormTextInput,
    FormNumberInput,
    PluginEditPanel,
  },
})
export default class PluginListPanel extends BaseComponent {
  static ID = 'PluginListPanel';

  plugins: Plugin[] = [];

  selectedPlugin: Plugin | null = null;

  mounted():void {
    this.plugins = this.pluginService.plugins;
  }

  onEdit(plugin: Plugin):void {
    this.selectedPlugin = plugin;
  }
}
</script>

<style scoped lang="less">
</style>
